import java.io.PrintStream;

import type.lib.Investment;
import type.lib.Stock;

/**
 * @author mb
 * 
 */
public class L06App03 {

	/**
	 * @param args
	 * @throws InterruptedException
	 */
	public static void main(String[] args) throws InterruptedException {
		PrintStream output = System.out;
		Stock stock1 = new Stock(".AB");
		// suppose we buy right now...
		int numShares = 10;
		double costRightNow = stock1.getPrice() * numShares;
		Investment inv1 = new Investment(stock1, numShares, costRightNow);
		output.print("Our investment: ");
		output.println(inv1);

		// let's wait 10 seconds or 10 x 1000 msec
		Thread.sleep(10000);

		// what would the same investment cost right now?
		inv1.getStock().refresh(); // ensure that we obtain the most recent
									// price for the stock, which may have
									// changed in the last 10 seconds
		double cost10SecondsLater = inv1.getStock().getPrice() * inv1.getQty();
		output.print("The cost of the investment 10 seconds later: ");
		output.println(cost10SecondsLater);

		// did our investment produce a profit or loss?
		output.print("Amt of profit, if any: ");
		output.printf("%.2f", cost10SecondsLater - inv1.getBookValue());

		// take home point: delimiter is not static; there is a copy
		// of this attribute for each instance and each may have it's own value.

	}
}
