import java.io.PrintStream;

import type.lib.Investment;
import type.lib.Stock;

/**
 * @author mb
 * 
 */
public class L06App04 {

	/**
	 * @param args
	 * @throws InterruptedException
	 */
	public static void main(String[] args) throws InterruptedException {
		PrintStream output = System.out;
		Stock stock1 = new Stock(".AB");
		// suppose we buy right now...
		int numShares = 10;
		double costRightNow = stock1.getPrice() * numShares;
		Investment inv1 = new Investment(stock1, 10, costRightNow);

		output.print("Our investment: ");
		output.println(inv1);

		// inv1 has a stock object as an aggregate part - is this
		// the same object as stock1?
		// what test should we use? == or .equals? why?
		output.println(inv1.getStock() == stock1);

		// now we set stock1 to null
		stock1 = null;

		Stock anotherStockRef = inv1.getStock();
		inv1 = null;
		output.println(anotherStockRef);

		// take home point: the stock object has a lifespan that is different
		// from the investment object; the investment object is orphaned and
		// hence dies; the stock aggregate part lives on because it is not
		// orphaned.
	}
}
