import java.io.PrintStream;

import type.lib.Investment;
import type.lib.Stock;

/**
 * @author mb
 * 
 */
public class L06App05 {

	/**
	 * @param args
	 * @throws InterruptedException
	 */
	public static void main(String[] args) throws InterruptedException {
		PrintStream output = System.out;
		Stock stock1 = new Stock(".AB");
		// suppose we buy right now...
		int numShares = 10;
		double costRightNow = stock1.getPrice() * numShares;
		Investment inv1 = new Investment(stock1, numShares, costRightNow);

		output.print("Our first investment: ");
		output.println(inv1);

		Investment inv2 = new Investment(inv1); // the API tells us that this
												// constructor makes a shallow
												// copy; we will examine what
												// this actually means
		output.print("Our second investment: ");
		output.println(inv2);

		output.print("Is our first investment represented by the same object than our second investment: ");
		output.println(inv1 == inv2);

		output.print("Does our first investment have the same aggregated Stock object as our second investment: ");
		output.println(inv1.getStock() == inv2.getStock());

		// e.g., we may have two different investment objects, but they both
		// share the same aggregated parts

		// a change to the aggregated part of inv2 will change the state of inv1...

		inv2.getStock().setSymbol(".ZZ");

		output.print("Our first investment: ");
		output.println(inv1);
		output.print("Our second investment: ");
		output.println(inv2);

	}
}
