import java.io.PrintStream;

import type.lib.Investment;
import type.lib.Stock;

/**
 * @author mb
 * 
 */
public class L06App06 {

	/**
	 * @param args
	 * @throws InterruptedException
	 */
	public static void main(String[] args) throws InterruptedException {
		PrintStream output = System.out;
		Stock stock1 = new Stock(".AB");
		// suppose we buy right now...
		int numShares = 10;
		double costRightNow = stock1.getPrice() * numShares;
		Investment inv1 = new Investment(stock1, numShares, costRightNow);

		output.print("Our first investment: ");
		output.println(inv1);

		// suppose we want a deep copy of inv1
		Stock stock2 = new Stock(".AB");
		Investment inv2 = new Investment(stock2, numShares, costRightNow);
		output.print("Our second investment: ");
		output.println(inv2);

		output.print("Is our first investment represented by the same object than our second investment: ");
		output.println(inv1 == inv2);

		output.print("Does our first investment have the same aggregated Stock object as our second investment: ");
		output.println(inv1.getStock() == inv2.getStock());

		// Does a change to the aggregated part of inv2 will change the state of
		// inv1?
		// Look to see evidence of impact on inv1 when we mutate the aggregated
		// part of inv2

		inv2.getStock().setSymbol(".ZZ");
		output.print("Our first investment: ");
		output.println(inv1);
		output.print("Our second investment: ");
		output.println(inv2);

	}
}
